#ifndef _MPLANTGRASS_H_
#define _MPLANTGRASS_H_

#include "m3dmath.h"

// hranicny stvoruholnik obsahujuci travu,
// resp. 2 hranicne trojuholniky obsahujuce travu
struct grassquad
{
 tVec3 v[4]; // vrcholy stvoruholnika, resp. vrcholy 2 trojuholnikov
};

// vzorky travy
struct grasssample
{
 short int x,y,z;    // poloha vzorky
 unsigned char c[3]; // farba vzorky
};

// pole stvoruholnikov obsahujucich travu
struct grassarray
{
 tVec3 o;                            // poloha stvoruholnika
 tVector<grassquad> *grassquads;     // zoznam stvoruholnikov
 tVector<grasssample> *grasssamples; // zoznam vzoriek
};

// trieda premennych a funkcii pre vytvorenie 3D travy
class PlantGrass {
public:
 // konstruktor
 PlantGrass();
 // destructor
 ~PlantGrass();

 // vykreslenie travy
 int Draw(float PX,float PY,float PZ,float TX,float TY,float TZ);
private:
 float gwidth,gheight; // sirka a vyska vzorky travy
 float ggrid;          // hustota vzoriek v hranicnom trojuholniku

 unsigned int numsamples; // aktualny pocet vzoriek travy

 float timeticks; // plynutie casu

 grassarray ga; // pole stvoruholnikov (trojuholnikov) obsahujucich travu

 tVec3 cpos,crot; // poloha a natocenie kamery
 tVec3 right;     // vektor smerujuci "doprava"

 tVec3 vv,tg;             // pomocne vektory
 tVec3 a1,a2,b1,b2,c1,c2; // pomocne vektory

 float dx,dy,dz,dd; // pomocne premenne
 float di,ld,w1,w2; // pomocne premenne

 // vypocet poloh jednotlivych vzoriek travy
 int SetGrassSamples(grassarray *ga,const tVec3 *v);
 // vykreslenie vzoriek travy
 int RenderGrassSamples(grassarray *ga,const tVec3 &v);
};

#endif
